This endpoint will provide you with the keyword popularity data from DataForSEO Trends. You can check keyword trends for Google Search, Google News, and Google Shopping.

How our algorithm works: Our algorithm provides insights into the popularity of specific keywords based on their association with relevant web pages, news articles, or shopping listings, as well as the popularity of each relevant piece of content. We also combine this information with anonymous user web behavior data from various sources. Learn more on our Help Center.

You will get information for every single keyword in an array.

You can send up to 5 keywords in one keywords array. Our system will charge your account per each request, no matter what number of keywords an array has.

Historical data for the web type: available from 2004-01-01;
Historical data for other types: available from 2008-01-01.

checked POST
Pricing

Your account will be charged for each request.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, each Live API call can contain only one task. The maximum number of requests that can be sent simultaneously is limited to 30.
Visit DataForSEO Help Center to get practical tips for request handling depending on your Keyword Data API payload volume.

Below you will find a detailed description of the fields you can use for setting a task.

Description of the fields for setting a task:

Field nameTypeDescription
keywordsarray

keywords
required field
the maximum number of keywords you can specify: 5

learn more about rules and limitations of keyword and keywords fields in DataForSEO APIs in this Help Center article

location_namestring

full name of search engine location
optional field
if you don't use this field, you will recieve global results
if you use this field, you don't need to specify location_code
you can receive the list of available locations of the search engine with their location_name by making a separate request to https://api.dataforseo.com/v3/keywords_data/dataforseo_trends/locations
note that the data will be provided for the country the specified location_name belongs to;
example:
United Kingdom

location_codeinteger

search engine location code
optional field
if you don't use this field, you will recieve global results
if you use this field, you don't need to specify location_name
you can receive the list of available locations of the search engines with their location_code by making a separate request to https://api.dataforseo.com/v3/keywords_data/dataforseo_trends/locations
note that the data will be provided for the country the specified location_code belongs to;
example:
2840

typestring

dataforseo trends type
optional field
if you don't specify this field, the web type will be used by default
possible values: web, news, ecommerce

date_fromstring

starting date of the time range
optional field
if you don't specify this field, the current day and month of the preceding year will be used by default
minimal value for the web type: 2004-01-01
minimal value for other types: 2008-01-01
date format: "yyyy-mm-dd"
example:
"2019-01-15"

date_tostring

ending date of the time range
optional field
if you don't specify this field, the today's date will be used by default
date format: "yyyy-mm-dd"
example:
"2019-01-15"

time_rangestring

preset time ranges
optional field
if you specify date_from or date_to parameters, this field will be ignored when setting a task
possible values for all type parameters:
past_4_hours, past_day, past_7_days, past_30_days, past_90_days, past_12_months, past_5_years

tagstring

user-defined task identifier
optional field
the character limit is 255
you can use this parameter to identify the task and match it with the result
you will find the specified tag value in the data object of the response



As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results

        keywordsarray

keywords in a POST array

        typearray

search engine type in a POST array

        location_codeinteger

location code in a POST array
if there is no data, then the value is_nulln

        language_codestring

language code in a POST array
if there is no data, then the value is_nulln

        datetimestring

date and time when the result was received
in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”
example:
2019-11-15 12:57:46 +00:00

        items_countinteger

the number of results returned in the items array

        itemsarray

contains keyword popularity and related data

            positioninteger

the alignment of the element
can take the following values: 1, 2, 3, 4, etc.

            typestring

type of element = ‘dataforseo_trends_graph’

            keywordsarray

relevant keywords
the data included in the dataforseo_trends_graph element is based on the keywords listed in this array

            dataarray

DataForSEO Trends data for the specified parameters

                date_fromstring

start date of the corresponding time range
in the UTC format: "yyyy-mm-dd"

                date_tostring

end date of the corresponding time range
in the UTC format: "yyyy-mm-dd"

                timestampinteger

a point in time in the Unix time format

                valuesarray

relative keyword popularity rate at a specific timestamp
represents the keyword popularity rate over the given time range
if you specify more than one keyword, the values will be averaged to the highest value across all specified keywords
a value of 100 is the peak popularity for the term. A value of 50 means that the term is half as popular. A score of 0 means there was not enough data for this term

            averagesarray

keyword popularity values averaged over the whole time range


‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/keywords_data/dataforseo_trends/explore/live" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
    {
        "keywords": [
            "iphone 14",
            "samsung s23"
        ],
        "location_code": 2840
    }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
try {
	// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
	$client = new RestClient($api_url, null, 'login', 'password');
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
	exit();
}
$post_array = array();
// simple way to set a task
$post_array[] = array(
	"location_code" => 2840,
	"keywords" => array(
		"iphone 14",
		"samsung s23"
	)
);
try {
	// POST /v3/keywords_data/dataforseo_trends/explore/live
	$result = $client->post('/v3/keywords_data/dataforseo_trends/explore/live', $post_array);
	print_r($result);
	// do something with post result
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
}
$client = null;
?>
const post_array = [];

post_array.push({
  "location_code": 2840,
  "keywords": ["iphone 14", "samsung s23"]
});

const axios = require('axios');

axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/keywords_data/dataforseo_trends/explore/live',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
    location_code=2840,
    keywords=[
        "iphone 14",
        "samsung s23"
    ]
)
# POST /v3/keywords_data/dataforseo_trends/explore/live
# the full list of possible parameters is available in documentation
response = client.post("/v3/keywords_data/dataforseo_trends/explore/live", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task keywords_data_dataforseo_trends_explore_live()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            postData.Add(new
            {
                location_code = 2840,
                keywords = new[]
                {
                    "iphone 14",
                    "samsung s23"
                }
            });
            // POST /v3/keywords_data/dataforseo_trends/explore/live
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/keywords_data/dataforseo_trends/explore/live", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
  "version": "0.1.20231117",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "7.9401 sec.",
  "cost": 0.001,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "01101318-1535-0570-0000-7492e81c4188",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "7.8817 sec.",
      "cost": 0.001,
      "result_count": 1,
      "path": [
        "v3",
        "keywords_data",
        "dataforseo_trends",
        "explore",
        "live"
      ],
      "data": {
        "api": "keywords_data",
        "function": "explore",
        "se": "dataforseo_trends",
        "keywords": [
          "iphone 14",
          "samsung s23"
        ],
        "location_code": 2840
      },
      "result": [
        {
          "keywords": [
            "iphone 14",
            "samsung s23"
          ],
          "type": "trends",
          "location_code": 2840,
          "language_code": null,
          "datetime": "2024-01-10 11:18:54 +00:00",
          "items_count": 1,
          "items": [
            {
              "position": 1,
              "type": "dataforseo_trends_graph",
              "keywords": [
                "iphone 14",
                "samsung s23"
              ],
              "data": [
                {
                  "date_from": "2023-01-15",
                  "date_to": "2023-01-21",
                  "timestamp": 1673740800,
                  "values": [
                    33,
                    22
                  ]
                },
                {
                  "date_from": "2023-01-22",
                  "date_to": "2023-01-28",
                  "timestamp": 1674345600,
                  "values": [
                    29,
                    8
                  ]
                },
                {
                  "date_from": "2023-01-29",
                  "date_to": "2023-02-04",
                  "timestamp": 1674950400,
                  "values": [
                    73,
                    80
                  ]
                },
                {
                  "date_from": "2023-02-05",
                  "date_to": "2023-02-11",
                  "timestamp": 1675555200,
                  "values": [
                    21,
                    14
                  ]
                },
                {
                  "date_from": "2023-02-12",
                  "date_to": "2023-02-18",
                  "timestamp": 1676160000,
                  "values": [
                    28,
                    18
                  ]
                },
                {
                  "date_from": "2023-02-19",
                  "date_to": "2023-02-25",
                  "timestamp": 1676764800,
                  "values": [
                    32,
                    13
                  ]
                },
                {
                  "date_from": "2023-02-26",
                  "date_to": "2023-03-04",
                  "timestamp": 1677369600,
                  "values": [
                    32,
                    10
                  ]
                },
                {
                  "date_from": "2023-03-05",
                  "date_to": "2023-03-11",
                  "timestamp": 1677974400,
                  "values": [
                    100,
                    1
                  ]
                },
                {
                  "date_from": "2023-03-12",
                  "date_to": "2023-03-18",
                  "timestamp": 1678579200,
                  "values": [
                    19,
                    5
                  ]
                },
                {
                  "date_from": "2023-03-19",
                  "date_to": "2023-03-25",
                  "timestamp": 1679184000,
                  "values": [
                    11,
                    6
                  ]
                },
                {
                  "date_from": "2023-03-26",
                  "date_to": "2023-04-01",
                  "timestamp": 1679788800,
                  "values": [
                    18,
                    14
                  ]
                },
                {
                  "date_from": "2023-04-02",
                  "date_to": "2023-04-08",
                  "timestamp": 1680393600,
                  "values": [
                    10,
                    3
                  ]
                },
                {
                  "date_from": "2023-04-09",
                  "date_to": "2023-04-15",
                  "timestamp": 1680998400,
                  "values": [
                    18,
                    4
                  ]
                },
                {
                  "date_from": "2023-04-16",
                  "date_to": "2023-04-22",
                  "timestamp": 1681603200,
                  "values": [
                    16,
                    2
                  ]
                },
                {
                  "date_from": "2023-04-23",
                  "date_to": "2023-04-29",
                  "timestamp": 1682208000,
                  "values": [
                    7,
                    2
                  ]
                },
                {
                  "date_from": "2023-04-30",
                  "date_to": "2023-05-06",
                  "timestamp": 1682812800,
                  "values": [
                    17,
                    7
                  ]
                },
                {
                  "date_from": "2023-05-07",
                  "date_to": "2023-05-13",
                  "timestamp": 1683417600,
                  "values": [
                    12,
                    0
                  ]
                },
                {
                  "date_from": "2023-05-14",
                  "date_to": "2023-05-20",
                  "timestamp": 1684022400,
                  "values": [
                    4,
                    0
                  ]
                },
                {
                  "date_from": "2023-05-21",
                  "date_to": "2023-05-27",
                  "timestamp": 1684627200,
                  "values": [
                    8,
                    3
                  ]
                },
                {
                  "date_from": "2023-05-28",
                  "date_to": "2023-06-03",
                  "timestamp": 1685232000,
                  "values": [
                    9,
                    1
                  ]
                },
                {
                  "date_from": "2023-06-04",
                  "date_to": "2023-06-10",
                  "timestamp": 1685836800,
                  "values": [
                    7,
                    3
                  ]
                },
                {
                  "date_from": "2023-06-11",
                  "date_to": "2023-06-17",
                  "timestamp": 1686441600,
                  "values": [
                    10,
                    3
                  ]
                },
                {
                  "date_from": "2023-06-18",
                  "date_to": "2023-06-24",
                  "timestamp": 1687046400,
                  "values": [
                    17,
                    2
                  ]
                },
                {
                  "date_from": "2023-06-25",
                  "date_to": "2023-07-01",
                  "timestamp": 1687651200,
                  "values": [
                    16,
                    4
                  ]
                },
                {
                  "date_from": "2023-07-02",
                  "date_to": "2023-07-08",
                  "timestamp": 1688256000,
                  "values": [
                    66,
                    3
                  ]
                },
                {
                  "date_from": "2023-07-09",
                  "date_to": "2023-07-15",
                  "timestamp": 1688860800,
                  "values": [
                    28,
                    0
                  ]
                },
                {
                  "date_from": "2023-07-16",
                  "date_to": "2023-07-22",
                  "timestamp": 1689465600,
                  "values": [
                    9,
                    0
                  ]
                },
                {
                  "date_from": "2023-07-23",
                  "date_to": "2023-07-29",
                  "timestamp": 1690070400,
                  "values": [
                    23,
                    3
                  ]
                },
                {
                  "date_from": "2023-07-30",
                  "date_to": "2023-08-05",
                  "timestamp": 1690675200,
                  "values": [
                    20,
                    1
                  ]
                },
                {
                  "date_from": "2023-08-06",
                  "date_to": "2023-08-12",
                  "timestamp": 1691280000,
                  "values": [
                    7,
                    2
                  ]
                },
                {
                  "date_from": "2023-08-13",
                  "date_to": "2023-08-19",
                  "timestamp": 1691884800,
                  "values": [
                    27,
                    1
                  ]
                },
                {
                  "date_from": "2023-08-20",
                  "date_to": "2023-08-26",
                  "timestamp": 1692489600,
                  "values": [
                    18,
                    0
                  ]
                },
                {
                  "date_from": "2023-08-27",
                  "date_to": "2023-09-02",
                  "timestamp": 1693094400,
                  "values": [
                    31,
                    2
                  ]
                },
                {
                  "date_from": "2023-09-03",
                  "date_to": "2023-09-09",
                  "timestamp": 1693699200,
                  "values": [
                    38,
                    3
                  ]
                },
                {
                  "date_from": "2023-09-10",
                  "date_to": "2023-09-16",
                  "timestamp": 1694304000,
                  "values": [
                    57,
                    1
                  ]
                },
                {
                  "date_from": "2023-09-17",
                  "date_to": "2023-09-23",
                  "timestamp": 1694908800,
                  "values": [
                    34,
                    5
                  ]
                },
                {
                  "date_from": "2023-09-24",
                  "date_to": "2023-09-30",
                  "timestamp": 1695513600,
                  "values": [
                    19,
                    6
                  ]
                },
                {
                  "date_from": "2023-10-01",
                  "date_to": "2023-10-07",
                  "timestamp": 1696118400,
                  "values": [
                    9,
                    8
                  ]
                },
                {
                  "date_from": "2023-10-08",
                  "date_to": "2023-10-14",
                  "timestamp": 1696723200,
                  "values": [
                    15,
                    5
                  ]
                },
                {
                  "date_from": "2023-10-15",
                  "date_to": "2023-10-21",
                  "timestamp": 1697328000,
                  "values": [
                    10,
                    3
                  ]
                },
                {
                  "date_from": "2023-10-22",
                  "date_to": "2023-10-28",
                  "timestamp": 1697932800,
                  "values": [
                    5,
                    0
                  ]
                },
                {
                  "date_from": "2023-10-29",
                  "date_to": "2023-11-04",
                  "timestamp": 1698537600,
                  "values": [
                    32,
                    5
                  ]
                },
                {
                  "date_from": "2023-11-05",
                  "date_to": "2023-11-11",
                  "timestamp": 1699142400,
                  "values": [
                    3,
                    3
                  ]
                },
                {
                  "date_from": "2023-11-12",
                  "date_to": "2023-11-18",
                  "timestamp": 1699747200,
                  "values": [
                    14,
                    0
                  ]
                },
                {
                  "date_from": "2023-11-19",
                  "date_to": "2023-11-25",
                  "timestamp": 1700352000,
                  "values": [
                    12,
                    2
                  ]
                },
                {
                  "date_from": "2023-11-26",
                  "date_to": "2023-12-02",
                  "timestamp": 1700956800,
                  "values": [
                    11,
                    1
                  ]
                },
                {
                  "date_from": "2023-12-03",
                  "date_to": "2023-12-09",
                  "timestamp": 1701561600,
                  "values": [
                    11,
                    3
                  ]
                },
                {
                  "date_from": "2023-12-10",
                  "date_to": "2023-12-16",
                  "timestamp": 1702166400,
                  "values": [
                    9,
                    3
                  ]
                },
                {
                  "date_from": "2023-12-17",
                  "date_to": "2023-12-23",
                  "timestamp": 1702771200,
                  "values": [
                    2,
                    0
                  ]
                },
                {
                  "date_from": "2023-12-24",
                  "date_to": "2023-12-30",
                  "timestamp": 1703376000,
                  "values": [
                    40,
                    2
                  ]
                },
                {
                  "date_from": "2023-12-31",
                  "date_to": "2024-01-10",
                  "timestamp": 1703980800,
                  "values": [
                    10,
                    0
                  ]
                }
              ],
              "averages": [
                22,
                6
              ]
            }
          ]
        }
      ]
    }
  ]
}